"""
  Popytka nahoditx sostaw smesi minimizaciej G kak
f-cii `isel molej produktow.
  Na primere C + H2O -> CO + H2 osoznano, `to neobh.
warxir. ne kol-wa produktow, a ko\f-ty pri reakciqh.
  Teku]. sost.: dlq NH3 wosproizw. polu`ennye ranee
rezulxtaty.
"""
print 'Pered import.'
from thermopy import nasa9polynomials as nasa9
from math import log
from sostaw_ import *
print 'Posle import.'

print 'Pered wwodom bazy.'
db = nasa9.Database()
print 'Posle wwoda bazy.'

# --------
"""
- ishodn - dlq udobnogo porqdka wywoda.
- n_ishodn0 - sostaw ishodn. smesi w molqh.
- reakcii - spisok reakcij, zapis. po tipu 
  ([(1,'N2O4')], [(2,'NO2')]) .
- T - po tipu (1000.,'oC') ili (1000, 'K').
- p - w atm.
"""

ishodn=['C(gr)', 'H2O']  
n_ishodn0={'C(gr)':1., 'H2O':2.}
reakcii=[
 ([(1,'C(gr)'), (1,'H2O')], [(1,'CO'), (1,'H2')]),
]
T_=(1000.,'oC')
p=1.  # atm


ishodn=['H2O(L)']
n_ishodn0={'H2O(L)':1.}
reakcii=[
 ([(1,'H2O(L)')], [(1,'H2O')]),
]
T_=(100.,'oC')
p=0.8  # atm


ishodn=['N2','H2']
n_ishodn0={'N2':1., 'H2':3.}
reakcii=[
 ([(1,'N2'), (3,'H2')], [(2,'NH3')]),
]
T_=(400.,'oC')
p=100.  # 1.  # atm


# --------

initio(db, ishodn,n_ishodn0,reakcii, T_,p)
f1=init_f1()

dq=0.5e-3
for iq1 in range(1,4000):
 q1=dq*iq1
 G=calc_G([q1])
 if G==None: continue  
 # Na slu`aj, esli takoj nabor ko\f-tow pri r-ciqh nerealizuem.
 nn=get_nn()
 dolq_NH3=nn[2]/(nn[0]+nn[1]+nn[2])
 # s=' '+str((dolq_NH3,G))+','
 s=' '+str(([q1],dolq_NH3,G))+','
 f1.write(s+'\n')
 print s

fini_f1()
