"""
  Popytka nahoditx sostaw smesi minimizaciej G kak
f-cii `isel molej produktow.
  Na primere C + H2O -> CO + H2 osoznano, `to neobh.
warxir. ne kol-wa produktow, a ko\f-ty pri reakciqh.
  Teku]ee sost.: dlq NH3 (edinstw. peremennaq) otrabotala 
minimizaciq - kak `erez fmin, tak i `erez sobstwenn. fmin_s .
"""
print 'Pered import.'
from thermopy import nasa9polynomials as nasa9
from math import log
from scipy.optimize import fmin
from mini7 import fmin_s
from sostaw_ import *
print 'Posle import.'

print 'Pered wwodom bazy.'
db = nasa9.Database()
print 'Posle wwoda bazy.'

# --------
"""
- ishodn - dlq udobnogo porqdka wywoda.
- n_ishodn0 - sostaw ishodn. smesi w molqh.
- reakcii - spisok reakcij, zapis. po tipu 
  ([(1,'N2O4')], [(2,'NO2')]) .
- T - po tipu (1000.,'oC') ili (1000, 'K').
- p - w atm.
"""

ishodn=['C(gr)', 'H2O']  
n_ishodn0={'C(gr)':1., 'H2O':2.}
reakcii=[
 ([(1,'C(gr)'), (1,'H2O')], [(1,'CO'), (1,'H2')]),
]
T_=(1000.,'oC')
p=1.  # atm


ishodn=['H2O(L)']
n_ishodn0={'H2O(L)':1.}
reakcii=[
 ([(1,'H2O(L)')], [(1,'H2O')]),
]
T_=(100.,'oC')
p=0.8  # atm


ishodn=['N2','H2']
n_ishodn0={'N2':1., 'H2':3.}
reakcii=[
 ([(1,'N2'), (3,'H2')], [(2,'NH3')]),
]
T_=(400.,'oC')
p=100.  # 1.  # atm


# --------

def functi(arg):
 print '-'*8
 G=calc_G(arg)
 print 'arg,G=',arg,G  # -> ...
 return(G)

initio(db, ishodn,n_ishodn0,reakcii, T_,p)
f1=init_f1()

for i in [1,2]:
 arg0=[0.2]
 if i==1:
  resu=fmin(functi, arg0, args=(), xtol=0.0001, maxiter=None)
 else: 
  resu=fmin_s(functi, arg0, args_e=(), xtol=0.0001, maxiter=1000)
 nn=get_nn()
 G=get_G()
 dolq_NH3=nn[2]/(nn[0]+nn[1]+nn[2])
 print 'dolq_NH3=',dolq_NH3
 s=' '+str((list(resu),dolq_NH3,G))+','
 f1.write(s+'\n')

fini_f1()
