"""
  Podprog. dlq popytok ras`@ta sostawa smesi 
minimizaciej G kak f-cii ko\f-tow pri reakciqh.
"""
from math import log

R= 8.314472  # Dv/(molx*grad)

def show_alle():
 print '--------\\'
 print 'p_atm=%4.2f' % (p,)
 print 'T_K,T_oC=(%7.2f, %7.2f)' % (T,T-273.15)
 for i in range(len(alle)):
  soed=alle[i]
  n=nn0[i]
  gaz=gazoobr[i]
  H,S,G=HSG[i]
  s='%-8s %6.2f %-5s %10.2f %8.2f %10.2f ' % (soed,n,gaz,H,S,G)
  for rea in reakcii:
   s+=('%2d ' % (rea[i]))
  print s
  T_=(H-G)/S
  assert abs(T_-T)/T<1e-5
 print '--------/'

def initio(db_e, ishodn_e,n_ishodn0_e,reakcii_e, T_e,p_e):
 """
 Primer:
 db = nasa9.Database()
 ishodn=['C(gr)', 'H2O']  # Dlq udobnogo porqdka wywoda.
 n_ishodn0={'C(gr)':1., 'H2O':2.} # Sostaw ishodn. smesi w molqh.
 reakcii=[
  ([(1,'C(gr)'), (1,'H2O')], [(1,'CO'), (1,'H2')]),
 ]
 T_=(1000.,'oC')
 p=1.  # atm
 """        
 global db,ishodn,n_ishodn0,reakcii_, T_,T,p
 global alle,nn0,nn,gazoobr,HSG,reakcii
 db=db_e
 ishodn=ishodn_e
 n_ishodn0=n_ishodn0_e
 reakcii_ = reakcii_e     
 T_=T_e
 T,edcy=T_; T=float(T)
 if edcy=='oC': T+=273.15
 p=p_e
 # ----
 alle=ishodn[:]
 for soed in n_ishodn0.keys(): assert soed in alle
 for isho,prod in reakcii_:
  ss=isho[:]; ss.extend(prod)
  for n,soed in ss:
   if not soed in alle: alle.append(soed)
 print 'alle=',alle
 # ----
 nn0,nn,gazoobr,HSG=[],[],[],[]
 for i in range(len(alle)):
  soed=alle[i]
  n=0.
  if soed in n_ishodn0: n=n_ishodn0[soed] 
  nn0.append(n)
  nn.append(n)
  comp = db.set_compound(soed)
  H=comp.enthalpy(T)
  S=comp.entropy(T)
  G=comp.gibbs_energy(T) 
  orig=comp.get_orig()
  s_cond=orig.find('condensed').text  # 'True'
  cond=eval(s_cond); gaz=not cond
  HSG.append((H,S,G))
  gazoobr.append(gaz)
 # ----
 reakcii=[]
 for isho,prod in reakcii_:
  rea=map(lambda x:0, alle)
  for n,soed in isho: i=alle.index(soed); assert rea[i]==0; rea[i]=-n
  for n,soed in prod: i=alle.index(soed); assert rea[i]==0; rea[i]=n
  reakcii.append(rea)
 # --------
 show_alle()

def test_nn():
 """
 Prower., `to `isla molej wseh we]estw >=0.
 Reag. tk. na n_i<0, t.k. dlq kondens. faz m.b. =0;
 slu`aj n_i=0 dlq gazow predp. proweritx tam, gde \to kriti`no. 
 """
 gut=True
 for i in range(len(alle)):
  if nn[i]<0: gut=False
 return(gut)

def recalc_nn(cc_rea):
 """
 Peres`@t `isla molej wseh we]-w iz izwestn.
 ko\f-tow pri reakciqh.
 """
 assert len(cc_rea)==len(reakcii)
 for i in range(len(alle)):
  nn[i]=nn0[i]
  for j in range(len(reakcii)):
   nn[i]+=cc_rea[j]*reakcii[j][i] 
 print 'nn=',nn
 gut=test_nn()
 return(gut)

def get_alle(): return(alle)

def get_nn(): return(nn)

def get_G(): return(G)

def calc_G(cc_rea):
 "nn - spisok - `isla molej soed-nij."
 global G
 gut=recalc_nn(cc_rea)
 if not gut: return(None)
 n_w_gaze=0.
 for i in range(len(alle)):
  if not gazoobr[i]: continue
  n_w_gaze+=nn[i]
 # print 'n_w_gaze=',n_w_gaze
 Sum_G=0.
 for i in range(len(alle)):
  soed=alle[i]
  H,S,G=HSG[i]
  if gazoobr[i]:
   if nn[i]==0.: print soed,'-> p_i=0 !!!'; return(None)
   p_i = p*nn[i]/n_w_gaze
   dS = -R*log(p_i)
   dG = -T*dS
  else:
   dG=0.
  Sum_G+=nn[i]*(G+dG)  
 G=Sum_G 
 return(Sum_G) 

def init_f1():
 global f1
 f1=open('tempor.py','ab')
 p=f1.tell()
 if p==0:
  f1.write('dann=[]\n')
 f1.write('# --------\n')
 f1.write('ishodn='+str(ishodn)+'\n')
 f1.write('n_ishodn0='+str(n_ishodn0)+'\n')
 f1.write('reakcii_=[\n')
 for rea in reakcii_:
  f1.write(' '+str(rea)+',\n')
 f1.write(']\n')
 f1.write('T_='+str(T_)+'\n')
 f1.write('p='+str(p)+'  # atm.\n')
 f1.write('alle='+str(alle)+'\n')
 f1.write('nn0='+str(nn0)+'\n')
 f1.write('T_oC='+str(T-273.15)+'\n')
 f1.write('p_atm='+str(p)+'\n')
 f1.write('q_G=[\n')
 f1.flush()
 return(f1)

def fini_f1():
 f1.write(']\n')
 f1.write('dann.append((T_oC,p_atm,q_G))\n')
 f1.close()
