"""
  Wyqsnenie struktury bazy 'burcat.xml'.
"""
from xml.etree import ElementTree as ET
import sys

tree = ET.ElementTree(file='burcat_thr.xml')
root = tree.getroot()

for specie in root:
 print '-'*8
 print specie.tag,specie.attrib,repr(specie.text)
 assert specie.tag=='specie'
 for child1 in specie:
  if child1.tag=='phase':
   print '    ',child1.tag,child1.attrib,repr(child1.text)
   for child2 in child1:
    if child2.tag in ['formula','temp_limit','coefficients']:
     print '    '*2,child2.tag,child2.attrib,repr(child2.text)
     if child2.tag=='coefficients':
      for child3 in child2: 
       print '    '*3,child3.tag,child3.attrib,repr(child3.text)
       if child3.tag in ['range_1000_to_Tmax','range_Tmin_to_1000']:
        for child4 in child3:
         print '    '*4,child4.tag,child4.attrib,repr(child4.text)
