#!/usr/bin/env python
"""
Simpleks-minimizaciq.
Podprog. minimizacii - fmin_s; sdelana po interfejsu podobnoj fmin
iz scipy.optimize; rabotaet huve, `em fmin.
"""
from geral import timestamp,ubr_0d0a,razbiwka
import os,sys

# --------

simpleks=[]
nr_min=-1; nr_max=-1  # nomera wer[in, sootw. min i max f.
ray=[];  # lu` iz wer[iny s max f k seredine protiwolev. grani i dalee.
delta=0.02

# --------

otlad=0

def zad_otlad(otlad_e):
 global otlad
 otlad=otlad_e

# --------

def sqr(x): return(x*x);

def LK2(c1,r1,c2,r2):
 r=map(lambda x,y:c1*x+c2*y,r1,r2)
 return(r)

def mini_init(r0):
 global N,Np1,aa
 N=len(r0); Np1=N+1
 aa=[-1.,-1./Np1,1.,None]
 # aa = zna`eniq koord-ty na linii ot wer[iny s naibolx[. zna`eniem
 # k seredine protiwoleva]ej grani; wer[ina - -1, sered. grani - 0;
 # -1/Np1 - centr simpleksa.

def zapis(tip,tocka):
 f1=open('history.dat','ab')
 r,f,comment=tocka
 s=tip+' / ';
 for i in range(N):
  s_='%14.12f' % (r[i],)
  s+=s_+' '
 s_='%14.12f' % (f,)
 s=s+'/ '+s_+' '+comment
 # A parame.txt ignoriruem - rekom. odin raz wnesti parametry
 # w history.dat w kommentarij i samomu sleditx, `toby oni ne menqlisx.
 print s
 f1.write(s+'\n')
 f1.close()

def sozd_tocku(tip,r):
 "tip = 's' dlq simpleksa i str(coef) dlq lu`a."
 f=functi(r)
 s_tim=timestamp()
 try: disk=os.environ['disk']
 except: disk='*'
 comment='# '+s_tim+' '+disk
 if otlad: print 'sozd_tocku: r,f=',r,'/',f;
 tocka=[r[:],f,comment]
 zapis(tip,tocka)
 return(tocka)

def dostr_simpleks(r0,delta):
 "~astx to`ek movet bytx pos`itana ranee i wwedena iz history.dat !"
 global simpleks
 print '----- dostr_simpleks -----\\'
 # print 'dostr_simpleks - pered prower./sozd. 0-j to`ki.'
 if len(simpleks)==0: 
  print 'sozd_simpleks - 0-q to`ka.'
  tocka=sozd_tocku('s',r0)
  simpleks.append(tocka)
 else:
  print 'dostr_simpleks: 0-q to`ka uve estx.'
 for i in range(N):
  ind=i+1
  # print 'dostr_simpleks - ind=',ind
  if ind>len(simpleks)-1: 
   print 'sozd_simpleks - '+str(ind)+'-q to`ka.'
   r=list(r0[:]); r[i]+=delta; 
   tocka=sozd_tocku('s',r)
   simpleks.append(tocka)
  else:
   print 'dostr_simpleks: '+str(ind)+'-q to`ka uve estx.'
 print '----- dostr_simpleks -----/'

def dostr_ray():
 global N,Np1,aa, simpleks,nr_min,nr_max,ray
 print '----- dostr_ray -----\\'
 nr_min,nr_max=opr_min_max(simpleks)
 print 'nr_min,nr_max=',nr_min,nr_max
 rm1,r0=opr_rm1_r0()  
 if otlad: print 'rm1=',rm1
 if otlad: print 'r0=',r0
 for i in range(4):
  # ~astx to`ek mogla bytx pos`itana ranx[e i wwedena iz fajla.
  print 'dostr_ray: i,len(ray)=',i,len(ray)
  if i<=len(ray)-1: continue
  if i==0:
   tocka=simpleks[nr_max]
  elif i==1 or i==2:
   coef=aa[i]
   r=LK2(-coef,rm1,(1+coef),r0)  
   # Prowerka: rassm.ko\f-ty pri rm1 i r0 pri warxir. coef;
   # coef=-1 -> 1 i 0,
   # coef= 0 -> 0 i 1. 
   tocka=sozd_tocku(str(coef),r)
  elif i==3:
   x1=-1.; y1=ray[0][1]
   x2=-1./Np1; y2=ray[1][1]
   x3=1.; y3=ray[2][1]
   if otlad:
    print 'Ocenka minimuma:'
    print x1,y1; print x2,y2; print x3,y3
   coef,f_ocen=ocen_min((x1,y1),(x2,y2),(x3,y3))
   if otlad: print '-> coef,f_ocen=',coef,f_ocen
   if coef<-0.8: coef=-0.8
   if coef>4.: coef=4.
   # if coef==0.: print 'ocen_min -> coef==0. - wyrovdenie !!!'; coef=0.1
   # Predp., `to izli[ne wytqnutye simpleksy w srednem -> zamedlenie na 
   # sledu;]ih [agah; pytaemsq izbegatx takowyh.
   if coef<0 and abs(coef)<1./Np1/2: coef=1./Np1/2
   if coef>0 and coef<0.25: coef=0.25
   r=LK2(-coef,rm1,(1+coef),r0)  
   tocka=sozd_tocku(str(coef),r)
  ray.append(tocka)
 print '----- dostr_ray -----/'

def opr_min_max(simpleks):
 "opr. nomera to`ek, sootw. min i max zna`eni;."
 global N,Np1
 assert len(simpleks)==Np1
 r,f,date=simpleks[0]
 imin=0; fmin=f; imax=0; fmax=f
 for i in range(N+1):
  r,f,date=simpleks[i]
  if f<fmin: imin=i; fmin=f
  if f>fmax: imax=i; fmax=f
 print 'opr_min_max: -> imin,imax=',imin,imax
 return(imin,imax)

def ocen_min(r1,r2,r3):
 """
 Ispolxz. w dostr_ray: (x1,y1) etc. - \to zna`eniq
 wdolx lu`a, i zamysel - najti minimum dlq paraboli`.
 podgonki zawis-sti minimiziruemoj f-cii wdolx lu`a. 
 """
 x1,y1=r1; x2,y2=r2; x3,y3=r3;
 cisl = y1*(sqr(x2)-sqr(x3)) + y2*(sqr(x3)-sqr(x1)) + y3*(sqr(x1)-sqr(x2));
 znam = y1*(x2-x3) + y2*(x3-x1) + y3*(x1-x2);
 xmin = (1/2.)*float(cisl)/znam
 x = xmin
 ymin = y1*( (x-x2)*(x-x3) )/( (x1-x2)*(x1-x3) ) \
      + y2*( (x-x1)*(x-x3) )/( (x2-x1)*(x2-x3) ) \
      + y3*( (x-x1)*(x-x2) )/( (x3-x1)*(x3-x2) );
 return(xmin,ymin)

def opr_rm1_r0():
 """
  Opr. rm1 = wer[inu, gde zna`enie maksimalxno,
i r0 - seredinu protiwopolovnoj grani.
 """
 global N,Np1,aa, simpleks,nr_min,nr_max,ray
 rm1=simpleks[nr_max][0]
 # print 'rm1=',rm1
 r0=map(lambda x:0.,rm1)
 if otlad: print 'r0=',r0
 for i in range(Np1):
  # print 'i,nr_max=',i,nr_max
  if i!=nr_max:
   r0=LK2(1.,r0,1.,simpleks[i][0]) 
   # print 'r0=',r0
 r0=map(lambda x:x/N,r0)
 # print 'r0=',r0
 return(rm1,r0)

def wwod_tocka(ss):
 """
   ss -wida
 ['s', '/', '5.', '10.', '/', '34.', '#', '2015-06-22', '12:38:46']
 ; nado preobr. w 
 [5., 10.], 34., '# 2015-06-22 12:38:46'] . 
 """
 r=[]
 assert ss[1]=='/'
 ind=2
 while ss[ind]!='/':
  x=float(ss[ind]); r.append(x); ind+=1
 f=float(ss[ind+1])
 comment=''
 for x in ss[ind+2:]: comment+=(x+' ')
 comment=comment[:-1]  # ubir. probel w konce
 tocka=[r,f,comment]
 return(tocka)

def wwod():
 """
   Wozm. situacii w konce raboty:
 - len(simpleks)<Np1 (w t.`. =0) => ili wy[li w konce cikla ili do 
   konca s`@ta 1-j to`ki, i net ni odnoj to`ki simpleksa, ili 
   pos`itana li[x `astx to`ek simpleksa;
 - len(ray)<len(aa) (w t.`. =0) => ne dos`itany to`ki lu`a.
 """
 global N,Np1,aa, simpleks,nr_min,nr_max,ray
 print '----- wwod -----\\'
 simpleks=[]; ray=[]
 try:
  f=open('history.dat','r')
 except:
  print 'Fajl history.dat otsutstwuet - s`@t wed@tsq ot na`ala.'
  print '----- wwod -----/'
  return
 revim='s' # s - wwod simpleksa, 'r' - wwod lu`a.
 while True:
  s=f.readline()
  if s=='': break
  if s[0]=='#': continue
  s=ubr_0d0a(s)
  try:
   s_=razbiwka(s)
   tip=s_[0]  # 's' ili coef.
   tocka=wwod_tocka(s_)
  except:
   print 'wwod: s=['+s+'] - !!!'; sys.exit(1) 
  print len(simpleks),len(ray),revim,tip,tocka
  if revim=='s':
   if tip=='s': simpleks.append(tocka)
   else:
    try: assert len(simpleks)==Np1
    except: print 'len(simpleks),Np1=',len(simpleks),Np1; sys.exit(1)
    if len(ray)==0:  # 1-q to`ka lu`a := wer[ina simpleksa s maks. zna`. celew. f-cii.
     nr_min,nr_max=opr_min_max(simpleks)
     ray.append(simpleks[nr_max])
    ray.append(tocka) 
    revim='r'
  else: # revim=='r'
   if tip!='s': ray.append(tocka)
   else: # tip=='s'
    try: assert len(ray)==4
    except: print 'len(ray)=',len(ray); sys.exit(1)
    simpleks=[]; ray=[]
    simpleks.append(tocka)
    revim='s'
 print 'wwod: len(ray)=',len(ray)
 print '----- wwod -----/'

def certa():
 f1=open('history.dat','ab')
 f1.write('# '+'-'*16+'\n')
 f1.close()

def wyw_simpleks():
 certa()
 for tocka in simpleks: zapis('s',tocka)

# --------

def fmin_s(functi_e, param0, args_e=[], xtol=1e-8, maxiter=1000):
 """
  Na otdelxnom [age prodwiveniq movet ne bytx (f=const wdolx linii);
fmax ili fmin na otdel. [age movet ne umenx[itsq (kogda estx nesk. to`ek
s odinakowym fmax ili fmin). Wywod: dlq  wywoda ob ostanowe nado
srawniwatx fmax (ili fmin, iii srednee po wsem to`kam) posle N [agow.
 """
 global functi,args,ray
 functi=functi_e
 mini_init(param0)
 bylo=[]
 print 'Pered wwodom.'
 wwod()
 print 'len(simpleks)=',len(simpleks)
 print 'len(ray)=',len(ray)

 count=0; fmax_=None
 while True:
  print '-'*32
  if len(simpleks)==0: certa()

  if len(simpleks)<Np1:
   if len(ray)==0:
    dostr_simpleks(param0,delta)
   else:
    print 'Nedopust. so`et.: simpleks ne dostroen, no luc estx!'
    sys.exit(1)

  nr_min,nr_max=opr_min_max(simpleks)
  print 'nr_min,nr_max=',nr_min,nr_max
  if nr_min==nr_max:
   print 'nr_min==nr_max; predp. - dostignut minimum.'
   break

  if len(ray)<len(aa):
   dostr_ray()

  imin=0; fmin=ray[0][1]
  for i in range(len(aa)):
   f=ray[i][1]
   if f<fmin: imin=i; fmin=f
  print 'na luce: imin=',imin
  simpleks[nr_max]=ray[imin]
  wyw_simpleks()
  nr_min,nr_max=opr_min_max(simpleks)
  fmax_=simpleks[nr_max][1]
  bylo.append(fmax_)
  if len(bylo)>Np1: bylo.pop()
  print 'fmax_= %14.12f'  % (fmax_,)

  ray=[]
  count+=1
  print 'count,maxiter=',count,maxiter

  s=''
  if count>maxiter:
   s='count,maxiter= %d %d - wyhodim.' % (count,maxiter)
  elif len(bylo)==Np1 and abs(bylo[0]-bylo[-1])<xtol:
   s='abs(...),xtol= %f %f - wyhodim.' % (bylo[0]-bylo[-1],xtol)
  if s:
   f1=open('history.dat','ab')
   print s; f1.write('# '+s+'\n'); 
   f1.close()
   break

 nr_min,nr_max=opr_min_max(simpleks)
 param_opt=simpleks[nr_min][0]
 return(param_opt)

# --------

def f_otlad(arg):
 "Dlq otladki." 
 x1,x2=arg
 f = (x1-2.)*(x1-2) + (x2-5.)*(x2-5.)
 print 'f_otlad: arg,f=',arg,f
 return(f)

# --------

if __name__=='__main__':
 param0=[6.,3.]
 param_opt=fmin_s(f_otlad, param0, args_e=[], xtol=1e-8, maxiter=1000)
 f=f_otlad(param_opt)
 print 'param_opt,f=',param_opt,f
